/** Dependencies **************************************************************/
#include <wixel.h>
#include <usb.h>
#include <usb_com.h>
#include <radio_queue.h>

#include <ctype.h>

//int32 CODE param_radio_channel = 128;//162; 2439,8428 2449,5804

/** xTea */
#include <xtea.h>
#include <stdio.h>

/** OLED */
#include <spi0_master.h>
#include <spi1_master.h>
#include <i2c.h>

#include "font6.h"

uint8 XDATA report[21];

#include "oled.h"

// OLED params
uint8 CODE param_i2c_on = 1;
uint8 CODE param_spi_on = 0;
uint8 CODE param_spi_number = 0;
uint8 CODE param_upside_down = 1; // Screen upside down
//int32 CODE param_height = 64;

/** Types *********************************************************************/
/*typedef struct incomeReport
{
    uint8 length;
    uint8 serialNumber[4];
    uint8 readings[8];
} incomeReport;*/

//uint8 XDATA buffer[8];
static uint8 CODE buffer[8] = {0x66,0x66,0x65,0x65,0x66,0x66,0x65,0x65};
uint8 XDATA key[16];
uint8 XDATA i, lent;

uint16 XDATA number_low = 0;
uint16 XDATA number_high = 0;
uint16 XDATA errorsCRC_low = 0;
uint16 XDATA errorsCRC_high = 0;
uint16 XDATA errorsDec = 0;

uint16 XDATA frequencyCHANNR;

/** Functions *****************************************************************/
void updateLeds(void)
{
    usbShowStatusWithGreenLed();
    LED_YELLOW(0);
    LED_RED(0);
}

void putchar(char c)
{
    usbComTxSendByte(c);
}

// type -> MBEDTLS_XTEA_ENCRYPT 1  MBEDTLS_XTEA_DECRYPT 0
uint8 * encrypt(uint8 * get, int type)
{
	uint8 XDATA input[8], output[8];
	
	mbedtls_xtea_context * enc = NULL;
	sprintf(input, get);
	
	mbedtls_xtea_init(enc);
	mbedtls_xtea_setup(enc, key);
	mbedtls_xtea_crypt_ecb(enc, type, input, output);
	mbedtls_xtea_free(enc);
	
	return output;
}

uint16 frequencyFromChannel(uint8 channel)
{
	uint32 XDATA freq = 34700;
	uint16 XDATA frequency;
	
	freq += 2864 * (uint32)channel;
	
	frequency = (uint16)(freq / 1000);
	
	if (freq % 1000 >= 500)
		frequency++;
	
	return frequency;
}

void radioToUsbService(void)
{
	uint8 XDATA * rxPacket;
	uint8 XDATA len, error;
	uint8 XDATA rinput[8], routput[8];
	uint8 XDATA reportLength;
	volatile uint16 XDATA position;
	
    // Check if there is a radio packet to report and space in the
    // USB TX buffers to report it.
    if ((rxPacket = radioQueueRxCurrentPacket())/* && usbComTxAvailable() >= 64*/)
    {
		// We received a packet from a Wiel, presumably one running
        // the wireless_adc_tx app.  Format it nicely and send it to
        // the USB host (PC).
		/*
		printf("|");
		printf("%c%c%c%c%c",
				rxPacket->length,
				rxPacket->serialNumber[0],
				rxPacket->serialNumber[1],
				rxPacket->serialNumber[2],
				rxPacket->serialNumber[3]
				);
		*/
		
		for (i = 0; i < 8; i++)
			rinput[i] = rxPacket[i + 5];
		//{
			//rinput[i] = rxPacket->readings[i];
			//printf("%c", rxPacket->readings[i]);
		//}
		
		sprintf(routput, encrypt(rinput, 0));
		
		/*
		printf("->");
		for (i = 0; i < 8; i++)
            printf("%c", routput[i]);
		printf("|");
		*/
		
		len = rxPacket[0];
		if (rxPacket[len + 2] & 0x80)
		{
			LED_YELLOW(1);
			number_low++;
		
			error = 0;
			for (i = 0; i < 8; i++)
				if (routput[i] != buffer[i])
					error = 1;
			errorsDec += error;
		}
		else
		{
			LED_RED(1);
			number_low++;
			errorsCRC_low++;
			if (errorsCRC_low >= 10000)
			{
				errorsCRC_high++;
				errorsCRC_low = 0;
			}
		}
		
		if (number_low >= 10000)
		{
			number_high++;
			number_low = 0;
		}
		
		oledClear();
		
		if (number_high > 1)
			reportLength = sprintf(report, "Packets:%5d%04d  Rx", number_high, number_low);
		else
			reportLength = sprintf(report, "Packets:     %4d  Rx", number_low);
		oledRow(reportLength, 1, param_upside_down);
		
		if (errorsCRC_high > 1)
			reportLength = sprintf(report, "Errors: %5d%04d CRC", errorsCRC_high, errorsCRC_low);
		else
			reportLength = sprintf(report, "Errors:      %4d CRC", errorsCRC_low);
		oledRow(reportLength, 2, param_upside_down);
		
		reportLength = sprintf(report, "Errors:     %5d dec", errorsDec);
		oledRow(reportLength, 3, param_upside_down);
		
		reportLength = sprintf(report, "RSSI:        %4d", ((int8)(rxPacket[len + 1])/2 - 71) == -327 ? -91 : (int8)(rxPacket[len + 1])/2 - 71);
		oledRow(reportLength, 4, param_upside_down);
		
		reportLength = sprintf(report, "LQI:         %4d", rxPacket[len + 2] & 0x7F);
		oledRow(reportLength, 5, param_upside_down);
		
		reportLength = sprintf(report, "Channel:      %3d", CHANNR);
		oledRow(reportLength, 6, param_upside_down);
		
		//reportLength = sprintf(report, "Frequency: 24%02d.%d MHz", frequencyFromChannel(CHANNR) / 10, frequencyFromChannel(CHANNR) % 10);
		reportLength = sprintf(report, "Frequency: 2.4%03d GHz", frequencyCHANNR);
		oledRow(reportLength, 7, param_upside_down);
		
		reportLength = sprintf(report, "Decipher:");
		oledRow(reportLength, 8, param_upside_down);
		
		position = param_upside_down ? 1023 - 128 * (8 - 1) - 6 * 11 : 128 * (8 - 1) + 6 * 11;
		
		for (i = 0; i < 8; i++)
		{
			if (isprint(routput[i]))
				position = oledLetter(routput[i], position, param_upside_down);
			else
				position = oledLetter('?', position, param_upside_down);
		}
		
        radioQueueRxDoneWithPacket();
    }
}

void main(void)
{
    systemInit();
    usbInit();
	
    radioQueueInit();
	radioQueueAllowCrcErrors = 1;
	
	oledInit(param_i2c_on, param_spi_on, param_spi_number);
	
	sprintf(key, "fffffffffffffff0");
	//sprintf(buffer, "ffeeffee");
	
	// Pull-up
	setDigitalInput(0, 1);  // Pause
	
	frequencyCHANNR = frequencyFromChannel(CHANNR);
	
    while(1)
    {
        updateLeds();
        boardService();
        //usbComService();
		//usbInputService();
		if (isPinHigh(0))   // Pause P0_0
			radioToUsbService();
			
		oledShow(param_i2c_on, param_spi_on, param_spi_number);
    }
}